#include "StdAfx.h"
#include "MaomiConfig.h"
#include <direct.h>

const LPTSTR CMaomiConfig::mcDescriptionsS[NUM_CONFIG] =
{
	"Top Left", "Top Center", "Top Right", 
	"Middle Left", "Middle Center", "Middle Right",
	"Bottom Left", "Bottom Center", "Bottom Right"
};

CMaomiConfig::CMaomiConfig(void)
{
	_tgetcwd(mConfigPathNameS, sizeof(mConfigPathNameS)/sizeof(TCHAR)-1);
	_tcscat(mConfigPathNameS, _T("\\"));
	_tcscat(mConfigPathNameS, INI_FILENAME);
	for (int n = 0; n < NUM_CONFIG; ++n) {
		mData[n].mAction = 0;
		mData[n].mCommandS[0] = '\0';
		mData[n].mDelay = 2;
		mData[n].mRadius = 25;
		mData[n].mDesktopOnly = true;
	}
}

CMaomiConfig::~CMaomiConfig(void)
{
}

bool CMaomiConfig::Load()
{
	TCHAR bufferS[64];
	TCHAR keywordS[64];
	int index = 0;
	int value;
	int varAssigned;

	FILE* fp = fopen(mConfigPathNameS, "rt");
	if (fp == NULL) return false;

	while (_fgetts(bufferS, sizeof(bufferS)/sizeof(TCHAR)-1, fp) != NULL) {
		switch (bufferS[0]) {
			case '[':
				_stscanf(bufferS, "[%[^]]]", keywordS);
				for (index = 0; index < sizeof(mcDescriptionsS)/sizeof(LPCTSTR); ++index) {
					if (_tcscmp(keywordS, mcDescriptionsS[index]) == 0) break;
				}
				break;
			case 'C':
				_stscanf(bufferS, "%[^=]=%[^\n]", keywordS, mData[index].mCommandS);
				break;
			default:
				varAssigned = _stscanf(bufferS, "%[^=]=%d", keywordS, &value);
				if (_tcscmp(keywordS, _T("Delay")) == 0) mData[index].mDelay = (varAssigned == 2)? value : 300;
				if (_tcscmp(keywordS, _T("Radius")) == 0) mData[index].mRadius = (varAssigned == 2)? value : 25;
				if (_tcscmp(keywordS, _T("DesktopOnly")) == 0) mData[index].mDesktopOnly = (varAssigned == 2)? (value ? true : false) : true;
				if (_tcscmp(keywordS, _T("Action")) == 0) mData[index].mAction = (varAssigned == 2)? value : 0;
				break;
		}
	}

	fclose(fp);
	return true;
}

bool CMaomiConfig::Save()
{
	FILE* fp = _tfopen(mConfigPathNameS, "wt");
	if (fp == NULL) return false;

	for (int n = 0; n < NUM_CONFIG; ++n) {
		_ftprintf(fp, _T("[%s]\n"), mcDescriptionsS[n]);
		_ftprintf(fp, _T("Delay=%d\n"), mData[n].mDelay);		
		_ftprintf(fp, _T("Radius=%d\n"), mData[n].mRadius);		
		_ftprintf(fp, _T("DesktopOnly=%d\n"), mData[n].mDesktopOnly? 1 : 0);
		_ftprintf(fp, _T("Action=%d\n"), mData[n].mAction);
		_ftprintf(fp, _T("Command=%s\n"), mData[n].mCommandS);
	}

	fflush(fp);
	fclose(fp);
	return true;
}