// MaomiDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Maomi.h"
#include "MaomiDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMaomiDlg dialog



CMaomiDlg::CMaomiDlg(CMaomiConfig* aConfigP, CWnd* pParent /*=NULL*/)
: CDialog(CMaomiDlg::IDD, pParent)
, mConfigP(aConfigP)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	mMenu.LoadMenu(IDR_TRAYMENU);
}

void CMaomiDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMaomiDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_CLOSE()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_MESSAGE(IDC_TRAYICON, OnTrayIcon)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_CBN_SELCHANGE(IDC_LOCATION, OnCbnSelchangeLocation)
	ON_COMMAND(ID_APP_EXIT, OnAppExit)
	ON_COMMAND(ID_TRAYMENU_RESTOREHIDE, OnTraymenuRestorehide)
	ON_BN_CLICKED(IDC_BROWSE, OnBnClickedBrowse)
END_MESSAGE_MAP()


// CMaomiDlg message handlers

BOOL CMaomiDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	CComboBox* comboBoxP = (CComboBox*)(GetDlgItem(IDC_LOCATION));
	comboBoxP->SetCurSel(0);
	UpdateDialogItems();

	// Minimize on start
	AddToTray();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMaomiDlg::OnClose()
{
	OnTraymenuRestorehide();
}

void CMaomiDlg::OnAppExit()
{
	RemoveFromTray();
	PostQuitMessage(0);
	CDialog::OnClose();
}

void CMaomiDlg::OnTraymenuRestorehide()
{
	if (IsWindowVisible()) {
		ShowWindow(SW_HIDE);		
		ModifyStyleEx(WS_EX_APPWINDOW, 0);
	}
	else {
		ModifyStyleEx(0, WS_EX_APPWINDOW);
		ShowWindow(SW_SHOW);
	}
}

void CMaomiDlg::AddToTray()
{
	mNotifyIconData.cbSize = sizeof(mNotifyIconData);
	mNotifyIconData.hWnd = GetSafeHwnd();
	mNotifyIconData.uID = IDC_TRAYICON;
	mNotifyIconData.uCallbackMessage = IDC_TRAYICON;
	mNotifyIconData.hIcon = m_hIcon;
	_tcscpy(mNotifyIconData.szTip, "Maomi");
	mNotifyIconData.uFlags = NIF_ICON | NIF_TIP | NIF_MESSAGE;

	Shell_NotifyIcon(NIM_ADD, &mNotifyIconData);
};

void CMaomiDlg::RemoveFromTray()
{
	Shell_NotifyIcon(NIM_DELETE, &mNotifyIconData);
}

LRESULT CMaomiDlg::OnTrayIcon(WPARAM wParam, LPARAM lParam)
{
	CPoint pt;
	GetCursorPos(&pt);

	switch (lParam) {
		case WM_LBUTTONDBLCLK:
			OnTraymenuRestorehide();
			break;
		case WM_RBUTTONDOWN:
			mMenu.GetSubMenu(IsWindowVisible() ? 1 : 0)->TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, pt.x, pt.y, this);
			break;
		default:
			break;
	}
	return 0;
}

void CMaomiDlg::OnBnClickedOk()
{
	UpdateConfigItems();
}

void CMaomiDlg::OnBnClickedCancel()
{
	UpdateDialogItems();
}

void CMaomiDlg::OnBnClickedBrowse()
{
	CFileDialog dlg(TRUE);
	if (dlg.DoModal() != IDOK) return;

	CEdit* commandEditP = (CEdit*)(GetDlgItem(IDC_COMMAND));
	commandEditP->SetWindowText(dlg.GetPathName());
}

void CMaomiDlg::OnCbnSelchangeLocation()
{
	UpdateDialogItems();
}

void CMaomiDlg::UpdateDialogItems()
{
	char bufferS[64];
	CComboBox* locationComboBoxP = (CComboBox*)(GetDlgItem(IDC_LOCATION));
	CComboBox* actionComboBoxP = (CComboBox*)(GetDlgItem(IDC_ACTION));
	CButton*   desktopOnlyCheckBoxP = (CButton*)(GetDlgItem(IDC_DESKTOP_ONLY));
	CEdit*     delayEditP = (CEdit*)(GetDlgItem(IDC_DELAY));
	CEdit*     radiusEditP = (CEdit*)(GetDlgItem(IDC_RADIUS));
	CEdit*     commandEditP = (CEdit*)(GetDlgItem(IDC_COMMAND));

	int nIndex = locationComboBoxP->GetCurSel();
	if (nIndex < 0) return;
	sprintf(bufferS, "%d", mConfigP->mData[nIndex].mRadius);
	radiusEditP->SetWindowText(bufferS);
	desktopOnlyCheckBoxP->SetCheck(mConfigP->mData[nIndex].mDesktopOnly ? BST_CHECKED : BST_UNCHECKED);
	sprintf(bufferS, "%d", mConfigP->mData[nIndex].mDelay);
	delayEditP->SetWindowText(bufferS);
	actionComboBoxP->SetCurSel(mConfigP->mData[nIndex].mAction);
	commandEditP->SetWindowText(mConfigP->mData[nIndex].mCommandS);	
}

void CMaomiDlg::UpdateConfigItems()
{
	TCHAR bufferS[32];
	CComboBox* locationComboBoxP = (CComboBox*)(GetDlgItem(IDC_LOCATION));
	CComboBox* actionComboBoxP = (CComboBox*)(GetDlgItem(IDC_ACTION));
	CButton*   desktopOnlyCheckBoxP = (CButton*)(GetDlgItem(IDC_DESKTOP_ONLY));
	CEdit*     delayEditP = (CEdit*)(GetDlgItem(IDC_DELAY));
	CEdit*     radiusEditP = (CEdit*)(GetDlgItem(IDC_RADIUS));
	CEdit*     commandEditP = (CEdit*)(GetDlgItem(IDC_COMMAND));

	int index = locationComboBoxP->GetCurSel();
	if (index < 0) return;
	radiusEditP->GetWindowText(bufferS, sizeof(bufferS)/sizeof(TCHAR) - 1);
	_stscanf(bufferS, "%d", &mConfigP->mData[index].mRadius);
	mConfigP->mData[index].mDesktopOnly = desktopOnlyCheckBoxP->GetCheck() == BST_CHECKED ? true : false;
	delayEditP->GetWindowText(bufferS, sizeof(bufferS)/sizeof(TCHAR) - 1);
	_stscanf(bufferS, "%d", &mConfigP->mData[index].mDelay);

	mConfigP->mData[index].mAction = actionComboBoxP->GetCurSel();
	commandEditP->GetWindowText(mConfigP->mData[index].mCommandS, sizeof(mConfigP->mData[index].mCommandS)/sizeof(TCHAR) - 1);
	mConfigP->Save();
}

